#include <iostream>
#include <vector>
#include <string>
#include <sstream>

int xor_delilaca(int x)
{
    std::vector<int> delioci;
    for (int i = 1; i <= x; i++)
    {
        if (x % i == 0)
            delioci.push_back(i);
    }
    int xor = delioci[0];
    for (size_t i = 1; i < delioci.size(); i++)
        xor = xor ^ delioci[i];
    return xor;
}

int main()
{
    std::string unos1, unos2;
    std::getline(std::cin, unos1);
    std::getline(std::cin, unos2);

    std::istringstream iss1(unos1);
    int n, k;
    iss1 >> n >> k;

    std::istringstream iss2(unos2);
    std::vector<int> niz(k);
    for (int i = 0; i < k; i++)
        iss2 >> niz[i];

    for (int broj : niz)
        std::cout << xor_delilaca(broj) << " ";

    return 0;
}